//+------------------------------------------------------------------+
//|                                         Directional_Breakout.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Yellow
#property indicator_color3 Yellow
#property indicator_color4 Red

extern int Price=0;    // Applied price
                       // 0 - Close
                       // 1 - Open
                       // 2 - High
                       // 3 - Low
                       // 4 - Median
                       // 5 - Typical
                       // 6 - Weighted
extern int Method=0;  // 0 - SMA
                      // 1 - EMA
                      // 2 - SMMA
                      // 3 - LWMA
extern int Length=20;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;

double UP[], N1[], N2[], DN[], trend[];

int init()
{
 IndicatorShortName("Directional Breakout");
 IndicatorDigits(Digits);
 IndicatorBuffers(5);
 SetIndexStyle(0,DRAW_HISTOGRAM);
 SetIndexBuffer(0,UP);
 SetIndexStyle(1,DRAW_HISTOGRAM);
 SetIndexBuffer(1,N1);
 SetIndexStyle(2,DRAW_HISTOGRAM);
 SetIndexBuffer(2,N2);
 SetIndexStyle(3,DRAW_HISTOGRAM);
 SetIndexBuffer(3,DN);
 SetIndexBuffer(4,trend);
 

 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
 if(Bars<=3) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 int pos;
 double MA;
 pos=limit;
 while(pos>=0)
 {
  MA=iMA(NULL, 0, Length, 0, Method, Price, pos);
  UP[pos]=EMPTY_VALUE;
  N1[pos]=EMPTY_VALUE;
  N2[pos]=EMPTY_VALUE;
  DN[pos]=EMPTY_VALUE;
  
  if (Low[pos]>MA)
  {
   UP[pos]=2.;
   trend[pos]=1;
  }
  else
  {
   if (High[pos]<MA)
   {
    DN[pos]=-2.;
      trend[pos]=-1;
   }
   else
   {
    N1[pos]=1.;
    N2[pos]=-1.;
      trend[pos]=0;
   }
  }

  pos--;
 } 
 
      if (alertsOn)
     {
       if (alertsOnCurrent)
            int whichBar = 0;
       else     whichBar = 1;
       if (trend[whichBar] != trend[whichBar+1])
       {
         if (trend[whichBar] ==  1) doAlert("up");
         if (trend[whichBar] == -1) doAlert("down");
         if (trend[whichBar] ==  0) doAlert("neutral");
      }         
     }
 return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Directional breakout changed status to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Wilders DMI "),message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Directional breakout " +" "+message));
             if (alertsSound)   PlaySound("alert2.wav");
      }
}